library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

Entity ens_ram_comm is 
    generic(
        id        : natural := 1;
		AXI_DATA_WIDTH : natural := 32
    );
    port 
    (
		-- Syscon signals
		reset     : in std_logic;
		clk       : in std_logic;
		-- axi signals
		addr_i 		: in std_logic_vector(1 downto 0);
		write_en_i  : in std_logic;
		writedata   : in std_logic_vector(AXI_DATA_WIDTH-1 downto 0);
		read_en_i	: in std_logic;
		readdata    : out std_logic_vector(AXI_DATA_WIDTH-1 downto 0);
		-- 
		start_acquisition_o : out std_logic;
		busy_i : in std_logic;
		--data
		data_val_i : in std_logic_vector(31 downto 0);
		data_addr_o : out std_logic_vector(9 downto 0)
    );
end entity ens_ram_comm;

-----------------------------------------------------------------------
Architecture ens_ram_comm_1 of ens_ram_comm is
-----------------------------------------------------------------------
	constant REG_ID     : std_logic_vector(1 downto 0) := "00";
	constant REG_STATUS : std_logic_vector(1 downto 0) := "01";
	constant REG_START	: std_logic_vector(1 downto 0) := "10";
	constant REG_DATA	: std_logic_vector(1 downto 0) := "11";

	signal data_addr_s : std_logic_vector(9 downto 0);
	signal readdata_s : std_logic_vector(AXI_DATA_WIDTH-1 downto 0);
begin
	data_addr_o <= data_addr_s;
	readdata <= readdata_s;

	-- manage register
	write_bloc : process(clk, reset)
	begin
		 if reset = '1' then 
			start_acquisition_o <= '0';
		 elsif rising_edge(clk) then
		 end if;
	end process write_bloc;

	read_bloc : process(clk, reset)
	begin
		if reset = '1' then
			readdata_s <= (others => '0');
			data_addr_s <= (others => '0');
		elsif rising_edge(clk) then
		end if;
	end process read_bloc;

end architecture ens_ram_comm_1;

